classification
Title: Document sitecustomize.py problems with pythonw
Type: Stage: resolved
Components: Library (Lib) Versions: Python 3.4, Python 3.5, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: piotr.dobrogost, python-dev, terry.reedy, willingc
Priority: normal Keywords: patch

Created on 2014-03-22 20:13 by terry.reedy, last changed 2014-04-29 04:33 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
issue21026.patch willingc, 2014-04-28 05:42 review
Messages (3)
msg214512 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-03-22 20:13
In the first section of the doc for site.py, after

"After these path manipulations, an attempt is made to import a module named sitecustomize, which can perform arbitrary site-specific customizations. It is typically created by a system administrator in the site-packages directory. If this import fails with an ImportError exception, it is silently ignored."

I propose to add (something like)

"If python is started without output streams available, as with pythonw on Windows (used by default to start Idle), attempted output from sitecustomize is ignored. Any exception other that ImportError causes a silent and perhaps mysterious failure of the process."

This issue was stimulated by someone asking on python-list about print() outout appearing when starting the console interpreter but not when starting Idle (on Windows).  I then tested the result of an excecption other than ImportError. At the console, nothing visible happens until a new prompt appears.

C:\Programs\Python34>pythonw -m idlelib.idle

C:\Programs\Python34>

If Idle is already running, the attempt to run a file with F5 gives a messages about not being able to connect to the subprocess (which silently failed).
msg217342 - (view) Author: Carol Willing (willingc) * (Python committer) Date: 2014-04-28 05:42
Updated documentation using Terry Reedy's suggested addition.
msg217465 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2014-04-29 04:33
New changeset 79a4560a702f by Terry Jan Reedy in branch '2.7':
Closes #21026: Augment site doc based on experiments. Patch by Carol Willing.
http://hg.python.org/cpython/rev/79a4560a702f

New changeset 3fef95842314 by Terry Jan Reedy in branch '3.4':
Issue #21026: Augment site doc based on experiments. Patch by Carol Willing.
http://hg.python.org/cpython/rev/3fef95842314
History
Date User Action Args
2014-04-29 04:33:14python-devsetstatus: open -> closed

nosy: + python-dev
messages: + msg217465

resolution: fixed
stage: needs patch -> resolved
2014-04-28 05:42:46willingcsetfiles: + issue21026.patch
nosy: + willingc
messages: + msg217342

2014-03-23 19:55:18piotr.dobrogostsetnosy: + piotr.dobrogost
2014-03-22 20:13:06terry.reedycreate